/* $Id: et6000_io.h,v 1.3 1998/11/24 18:45:21 marcus Exp $
******************************************************************************

   Tseng Labs ET6000 IO/state structures and prototypes

   Copyright (C) 1997           Jim Ursetto     [jim.ursetto@ggi-project.org]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

#ifndef _ET6000_IO_H
#define _ET6000_IO_H

#include <kgi/module.h>

#define INS1r INS1rc
#define CRTI  CRTIc
#define CRTD  CRTDc

#define NoSEQRegs   0x08                                                  
#define NoCRTRegs   0x40                                                  
#define NoGRCRegs   0x09                                                  
#define NoATCRegs   0x18                                                  
#define NoPCIRegs   0x87
   
struct statetable                                                         
{                                                                         
	kgiu8 MISC;                                                       
	kgiu8 SEQ[NoSEQRegs];                                         
	kgiu8 CRT[NoCRTRegs];                                     
	kgiu8 GRC[NoGRCRegs];                                 
	kgiu8 ATC[NoATCRegs];                             
	kgiu8 PCIVidCtrl1;                            
};                                                                        
   
void save_state(struct statetable *state);
void restore_state(struct statetable *state);
void dump_state(struct statetable *state);
void enable_ext(void);
void disable_ext(void);


void PCI_out8(struct kgi_display *dpy, kgiu8 value, kgiu8 reg);
kgiu8 PCI_in8(struct kgi_display *dpy, kgiu8 reg);
void CLK_out8(struct kgi_display *dpy,kgiu8 value,kgiu8 reg);
kgiu8 CLK_in8(struct kgi_display *dpy,kgiu8 reg);
void DAC_out8(struct kgi_display *dpy,kgiu8 value, kgiu8 dac_reg);
kgiu8 DAC_in8(struct kgi_display *dpy,kgiu8 dac_reg);
void DAC_ins8(struct kgi_display *dpy,kgiu8 dac_reg,void *buf, uint count);
void DAC_outs8(struct kgi_display *dpy,kgiu8 dac_reg, void *buf, uint count);

kgiu8 MISC_in8(void);
kgiu8 CRT_in8(kgiu8 reg);
kgiu8 GRC_in8(kgiu8 reg);
kgiu8 SEQ_in8(kgiu8 reg);
void ATC_out8(kgiu8 value, kgiu8 reg);
void CRT_out8(kgiu8 value, kgiu8 reg);
void GRC_out8(kgiu8 value, kgiu8 reg);
void MISC_out8(kgiu8 value);
void SEQ_out8(kgiu8 value, kgiu8 reg);

#endif /* _ET6000_IO_H */
